import numpy as np
import random 
import copy 


'''
S收到感染进行转换的各种情况
'''
choose = [0,1,3,4,6,7]
#0是隔离Q，1是易感S，3是潜伏E，4是感染I，6是恢复R，7是死亡D（仅作说明，不进程序）


'''
无管控
'''
def no_force(x, len_nodes, itselves, E_days, neibors, beita1):
	E_days[x] = 0
	
	for y in neibors[x]:			#遍历节点x的邻居节点y，在itselves上即为节点y的索引
		if itselves[x] == 1:
			n = np.random.random( )
			if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着
				if n < beita1:
					itselves[x] = 3
				else:
					continue
			else:
				continue
		else:
			continue 

	return itselves[x],E_days[x]

'''
仅有组内管控
'''
def in_force(x, len_nodes, itselves, E_days, neibors, cluster, beita, beita1, force_in):
	E_days[x] = 0
	a = np.random.random()
	
	for y in neibors[x]:			#遍历节点x的邻居节点y，在itselves上即为节点y的索引
		if itselves[x] == 1:
			n = np.random.random()
			if cluster[x] == cluster[y]:	#同社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着
					if n < beita1*force_in:
						itselves[x] = 3
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
							
			else:							#不同社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着\隔离者
					if n < beita1:
						itselves[x] = 3
						break
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
		else:
			continue
				
	return itselves[x],E_days[x] 


'''
仅有组间管控
'''
def out_force(x, len_nodes, itselves, E_days, neibors, cluster, beita, beita1, force_out):
	E_days[x] = 0
	a = np.random.random()
	
	for y in neibors[x]:			#遍历节点x的邻居节点y，在itselves上即为节点y的索引
		if itselves[x] == 1:
			n = np.random.random( )
			if cluster[x] == cluster[y]:	#同社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着/隔离者
					if n < beita1:
						itselves[x] = 3
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
				
			else:							#不同社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着/隔离者
					if n < beita1*force_out:
						itselves[x] = 3
						break
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
		else:
			continue
				
	return itselves[x],E_days[x] 


'''
组间和组内同时管控
'''
def two_force(x, len_nodes, itselves, E_days, neibors, cluster, beita, beita1, force_in, force_out):
	E_days[x] = 0
	a = np.random.random( )
	
	for y in neibors[x]:			#遍历节点x的邻居节点y，在itselves上即为节点y的索引
		if itselves[x] == 1:
			n = np.random.random( )
			if cluster[x] == cluster[y]:	#same社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着/隔离者
					if n < beita1*force_in:
						itselves[x] = 3
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
				
			else:							#不同社群
				if itselves[y] == 4:		#易感者S被确诊者I传染的情况，变成潜伏着/隔离者
					if n < beita1*force_out:
						itselves[x] = 3
						break
					else:					#易感者中可能被隔离Q的人
						if a < (beita-beita1):
							itselves[x] = 0
						else:
							continue
		else:
			continue
				
	return itselves[x],E_days[x] 
